;special wrappers over two frame buttons
(document:surround "/std/base")

(document:envelop with-translation _ "alterator-installer")

;;;;;;;;;;;;;;;;
(define (frame:make-wizardface . args)
  (with-container-presentations
   ((wizardface '(/std/primitive type "wizardface")))
   (begin-1 (document:id wizard-id (apply wizardface args))
            (set-global! 'frame:wizard wizard-id))))

(define (frame:help)
  ((global 'frame:page)
   help (woo-get-option (woo-read-first (string-append "/help/" (topic))) 'path)))

;;;;;;;;;;;;;;;;;

(define (frame:replace url . args)
  (frame:clear-on-next)
  (frame:clear-on-back)
  (frame:next-activity #t)
  (frame:back-activity #t)
  (apply document:replace-in-widget (global 'frame:page) url args))

;;(define (frame:make-page url . args)
;;  (begin-1 (document:id page-id (apply document:subdocument url args))
;;           (set-global! 'frame:page page-id)))
(define (frame:make-page)
  (begin-1 (document:id page-id (document:subdocument "/std/box" orientation "vertical"))
           (set-global! 'frame:page page-id)))

;;;;;;;;;;;;;;;;;;; standalone compatibility

(define (frame:on-leave thunk) 'missing)
(define (frame:on-apply thunk) 'missing)
(define (frame:buttons-view . args) args)

;;;;;;;;;;;;;;;;
(define (frame:on-* name thunk)
  (let ((on-* (global name)))
       (and on-* (cell-set! on-* thunk))))
(define (frame:clear-on-* name)
  (let ((on-* (global name)))
    (and on-* (cell-set! on-* #f))))

;;;;;;;;;;;;;;;;;;; wizard step callbacks
(define (frame:on-back thunk)
  (frame:on-* 'frame:back thunk))
(define (frame:clear-on-back)
  (frame:clear-on-* 'frame:back))

(define (frame:on-next thunk)
  (frame:on-* 'frame:next thunk))
(define (frame:clear-on-next)
  (frame:clear-on-* 'frame:next))

;;;;;;;;;;;;;;;;;;;;;; wizard steps
(define (frame:next)
  (let ((p (global 'frame:next-button)))
    (and (procedure? p) (p))))
(define (frame:back)
  (let ((p (global 'frame:back-button)))
    (and (procedure? p) (p))))
(define (frame:end)
  (let ((p (global 'frame:end-button)))
    (and (procedure? p) (p))))

(define (frame:set-next thunk)
  (set-global! 'frame:next-button thunk))
(define (frame:set-back thunk)
  (set-global! 'frame:back-button thunk))
(define (frame:set-end thunk)
  (set-global! 'frame:end-button thunk))

(define (frame:skip)
  (if (eq? (global 'frame:direction) 'back)
      (frame:back)
      (frame:next)))

;;;;;;;;;;;;;;;;;;;;;; wizard buttons
(define (frame:enable/disable-some name value)
  (let ((p (global 'frame:wizard)))
    (and (procedure? p)
         (p action-activity name value))))

(define (frame:next-activity value)
  (frame:enable/disable-some 'forward value)
  (frame:enable/disable-some 'finish value))
(define (frame:back-activity value)
  (frame:enable/disable-some 'backward value))
